Skip to content
Start here

Upload Custom Origin Trust Store

client.acm.customTrustStore.create(CustomTrustStoreCreateParams { zone_id, certificate } params, RequestOptionsoptions?): CustomTrustStore { id, certificate, expires_on, 5 more }
POST/zones/{zone_id}/acm/custom_trust_store

Add Custom Origin Trust Store for a Zone.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
SSL and Certificates Write
ParametersExpand Collapse
params: CustomTrustStoreCreateParams { zone_id, certificate }
zone_id: string

Path param: Identifier.

maxLength32
certificate: string

Body param: The zone's SSL certificate or certificate and the intermediate(s).

ReturnsExpand Collapse
CustomTrustStore { id, certificate, expires_on, 5 more }
id: string

Identifier.

maxLength32
certificate: string

The zone's SSL certificate or certificate and the intermediate(s).

expires_on: string

When the certificate expires.

formatdate-time
issuer: string

The certificate authority that issued the certificate.

signature: string

The type of hash used for the certificate.

status: "initializing" | "pending_deployment" | "active" | 3 more

Status of the zone's custom SSL.

One of the following:
"initializing"
"pending_deployment"
"active"
"pending_deletion"
"deleted"
"expired"
updated_at: string

When the certificate was last modified.

formatdate-time
uploaded_on: string

When the certificate was uploaded to Cloudflare.

formatdate-time

Upload Custom Origin Trust Store

import Cloudflare from 'cloudflare';

const client = new Cloudflare({
  apiToken: process.env['CLOUDFLARE_API_TOKEN'], // This is the default and can be omitted
});

const customTrustStore = await client.acm.customTrustStore.create({
  zone_id: '023e105f4ecef8ad9ca31a8372d0c353',
  certificate:
    '-----BEGIN CERTIFICATE-----\nMIIDdjCCAl6gAwIBAgIJAPnMg0Fs+/B0MA0GCSqGSIb3DQEBCwUAMFsx...\n-----END CERTIFICATE-----\n',
});

console.log(customTrustStore.id);
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "certificate": "-----BEGIN CERTIFICATE-----\nMIIDdjCCAl6gAwIBAgIJAPnMg0Fs+/B0MA0GCSqGSIb3DQEBCwUAMFsx...\n-----END CERTIFICATE-----\n",
    "expires_on": "2122-10-29T16:59:47Z",
    "issuer": "GlobalSign",
    "signature": "SHA256WithRSA",
    "status": "active",
    "updated_at": "2014-01-01T05:20:00Z",
    "uploaded_on": "2014-01-01T05:20:00Z"
  }
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "success": true,
  "result": {
    "id": "023e105f4ecef8ad9ca31a8372d0c353",
    "certificate": "-----BEGIN CERTIFICATE-----\nMIIDdjCCAl6gAwIBAgIJAPnMg0Fs+/B0MA0GCSqGSIb3DQEBCwUAMFsx...\n-----END CERTIFICATE-----\n",
    "expires_on": "2122-10-29T16:59:47Z",
    "issuer": "GlobalSign",
    "signature": "SHA256WithRSA",
    "status": "active",
    "updated_at": "2014-01-01T05:20:00Z",
    "uploaded_on": "2014-01-01T05:20:00Z"
  }
}